> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Rotate Workflow Webhook Secret

> Rotates the webhook secret for a workflow.

`Unary` · [`Workflows`](https://ona.com/docs/api-reference/generated/workflow/overview)

Rotates the webhook secret for a workflow.

Use this method to:

* Generate a new webhook secret
* Invalidate the old webhook secret

### Examples

* Rotate webhook secret:

  Generates a new webhook secret for the workflow.

  ```yaml theme={null}
  workflowId: "b0e12f6c-4c67-429d-a4a6-d9838b5da047"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.WorkflowService/RotateWorkflowWebhookSecret
```

Send a Bearer token as described in [Authentication](https://ona.com/docs/api-reference.md#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

```bash cURL theme={null}
export ONA_HOST=https://app.ona.com
export ONA_API_KEY=<your-token>

curl --request POST \
  --url "$ONA_HOST/api/gitpod.v1.WorkflowService/RotateWorkflowWebhookSecret" \
  --header "Authorization: Bearer $ONA_API_KEY" \
  --header "Content-Type: application/json" \
  --data '{
  "workflowId": "<workflow-id>"
}'
```

```python Python theme={null}
import gitpod.v1.workflow_pb2 as workflow_pb2
from ona_sdk import create_client_from_env

ona = create_client_from_env()
request = workflow_pb2.RotateWorkflowWebhookSecretRequest(
    workflow_id="<workflow-id>",
)
response = ona.services.workflow.rotate_workflow_webhook_secret(request)
print(response)
```

```typescript TypeScript theme={null}
import { create } from "@bufbuild/protobuf";
import { createClientFromEnv } from "@gitpod/sdk";
import { RotateWorkflowWebhookSecretRequestSchema } from "@gitpod/sdk/gitpod/v1/workflow_pb";

async function main() {
  const ona = createClientFromEnv();
  const request = create(RotateWorkflowWebhookSecretRequestSchema, {
    workflowId: "<workflow-id>",
  });
  const response = await ona.services.workflow.rotateWorkflowWebhookSecret(request);
  console.log(response);
}

main().catch(console.error);
```

```go Go theme={null}
package main

import (
	"context"
	"fmt"
	"log"

	"connectrpc.com/connect"
	"github.com/gitpod-io/gitpod-sdk-go/sdk"
	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
)

func main() {
	ona, err := sdk.NewFromEnv()
	if err != nil {
		log.Fatal(err)
	}

	request := connect.NewRequest(&gitpodpb.RotateWorkflowWebhookSecretRequest{
		WorkflowId: "<workflow-id>",
	})
	response, err := ona.Services.Workflow.RotateWorkflowWebhookSecret(context.Background(), request)
	if err != nil {
		log.Fatal(err)
	}
	fmt.Println(response.Msg)
}
```

```json Request body theme={null}
{
  "workflowId": "<workflow-id>"
}
```

## Request

`gitpod.v1.RotateWorkflowWebhookSecretRequest`

| Field | Type | Required | Description |
| - | - | - | - |
| `workflowId` | string | No | Constraints: `string.uuid=true`. |

## Response

`gitpod.v1.RotateWorkflowWebhookSecretResponse`

| Field | Type | Required | Description |
| - | - | - | - |
| `secret` | string | No | The new webhook secret (decrypted) |


This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.